/* graphics filter for gigi or VT240 terminal                     */
#include <stdio.h>
#define ESC 27          /* ASCII escape                 */
#define XDOTS 480.0
#define YDOTS 480.0
    /* really 768 dots in x direction, but want square graphs */
double getcoord();

main(){
int code,c,i,xgigi,ygigi;
double xmin,xmax,ymin,ymax,xscale,yscale,xdel,ydel,xcurrent,ycurrent;
char label[128];
    xmin = 0.0;         ymin = 0.0;     /* defaults */
    xmax = 1000.0;      ymax = 1000.0;
    xdel = (xmax-xmin)/XDOTS;   ydel = (ymax-ymin)/YDOTS;
    xscale = 1.0/xdel;          yscale = 1.0/ydel;
    printf("%cPpW(I7)W(P11111111)W(P(M2))",ESC);
    /* turn on graphics mode and reset line style */
    /* set default modes: color = white, linestyle = solid, multiplier = 2. */
    while( (code = getchar()) != EOF)switch(code){
        case 'e': printf("S(E)");    /* erase screen */
                break;
        case 's': xmin = getcoord();    /* set up plotting window */
                ymin = getcoord();
                xmax = getcoord();
                ymax = getcoord();
                xdel = (xmax-xmin)/XDOTS;       ydel = (ymax-ymin)/YDOTS;
                xscale = 1.0/xdel;              yscale = 1.0/ydel;
                break;
        case 'm':                       /* read in current point */
                xcurrent = getcoord();
                ycurrent = getcoord();
		xgigi = (xcurrent-xmin)*xscale;
		ygigi = (ymax-ycurrent)*yscale;
		printf("P[%d,%d]",xgigi,ygigi);
                break;
        case 'p':                       /* plot a point */
                xcurrent = getcoord();
                ycurrent = getcoord();
		xgigi = (xcurrent-xmin)*xscale;
		ygigi = (ymax-ycurrent)*yscale;
		printf("P[%d,%d]V[]",xgigi,ygigi);
                break;
        case 'l':                       /* plot a line  */
                xcurrent = getcoord();
                ycurrent = getcoord();
		xgigi = (xcurrent-xmin)*xscale;
		ygigi = (ymax-ycurrent)*yscale;
		printf("P[%d,%d]",xgigi,ygigi);
                        /* continue on into case 'n' */
        case 'n':                       /* line from current to next*/
                xcurrent = getcoord();
                ycurrent = getcoord();
		xgigi = (xcurrent-xmin)*xscale;
		ygigi = (ymax-ycurrent)*yscale;
		printf("V[%d,%d]",xgigi,ygigi);
                break;
        case 't':       /* put a label in the graph */
		gets(label);
		for(i=0;i<strlen(label);i++)if(label[i] == '\'')label[i]='"';
		/* single quote is gigi string separator */
		printf("T'%s'",label);
                break;
        case 'a':       /* draw an arc */
                fprintf(stderr,"don't know how to draw arcs\n");
                for(i=0;i<6;i++)(void)getcoord();       /* flush it */
                break;
        case 'c':       /* draw a circle */
                fprintf(stderr,"don't know how to draw circles\n");
                for(i=0;i<3;i++)(void)getcoord();       /* flush it */
                break;
        case 'f':       /* change linestyle */
		gets(label);
		if(strcmp(label,"solid")==0)
			printf("W(P11111111)");
		else if(strcmp(label,"dotted")==0)
			printf("W(P10011001)");
		else if(strcmp(label,"shortdashed")==0)
			printf("W(P11000011)");
		else if(strcmp(label,"longdashed")==0)
			printf("W(P(M4))W(P11000011)");
		else if(strcmp(label,"dotdashed")==0)
			printf("W(P(M4))W(P10011100)");
		break;
        default: fprintf(stderr,"unknown code = %c\n",code);
    }
    printf("%c\\",ESC);		/* turn off graphics mode */
}
 
double getcoord(){
int c,d;
   c = getchar();
    d = getchar();
    return( (double)((d<<8)|c) );
}
