/* UNIX graphics filter for SUN monitor - cgi version			*/
/* 1/10/89 Doug Toussaint					*/
/* not neat, but compatible with old UNIX graphics		*/
/* to compile:							*/
/* cc -o pcgi -O -fsingle pcgi.c -lcgi -lsunwindow -lpixrect -lm  */
#include <stdio.h>
#include <cgidefs.h>

#define LINEWIDTH 0.2	/* in units of 1% of VDC space */
#define POINTSIZE 0.5	/* This seems to do nothing    */
Cfloat linewidth;
Cfloat scale;		/* overall scale factor */

int getcoord();
int bw2dd(),pixwindd();	/* sun 2 bw monitor or graphics window */
Cvwsurf our_surf;
Cint surf_name;
Ccoor coords[2];	/* [0] is last point, [1] is current */
#define CURRENT coords[1]
#define LAST coords[0]
Ccoorlist clist,plist;
Ccoor lowerleft,upperright;
char *getenv();

main(argc,argv) int argc; char **argv; {
int code,i,j;
float xx;
char label[128];
    linewidth=LINEWIDTH;
    scale=1.0;
    clist.n=2;
    clist.ptlist = coords;
    plist.n=1;
    plist.ptlist = &(coords[1]);

   /* read options */
   for(i=1;i<argc;i++){
       if(strcmp(argv[i],"-w")==0){
	   if(i==argc-1) fprintf(stderr,"Missing pcgi linewidth option\n");
	   else if(sscanf(argv[++i],"%e",&xx) == 1){
	       linewidth=xx;
	   }
	   else fprintf(stderr,"Bad pcgi linewidth option %s\n",argv[i]);
       }
       else if(strcmp(argv[i],"-s")==0){
	   printf("pcgi does not do scaling yet!!!\n");
	   if(i==argc-1) fprintf(stderr,"Missing pcgi scale option\n");
	   else if(sscanf(argv[++i],"%e",&xx) == 1) scale=xx;
	   else fprintf(stderr,"Bad pcgi scale option %s\n",argv[i]);
       }
       else fprintf(stderr,"Illegal pcgi option %s\n",argv[i]);
   }

    /* decide whether we are going to a raw screen or a window */
    if(getenv("WINDOW_ME") == NULL){
	NORMAL_VWSURF(our_surf,BW2DD);
    }
    else{
	NORMAL_VWSURF(our_surf,PIXWINDD);
    }
    if( open_cgi() )exit(1);
    if( open_vws(&surf_name,&our_surf) )exit(2);
    line_width_specification_mode(SCALED);
    line_width(linewidth);
    marker_type(CIRCLE);
    marker_size_specification_mode(SCALED);
    marker_size(linewidth);

    /* now begin translating input file to SunCore calls */
    while( (code = getchar()) != EOF)switch(code){
        case 'e':
		if( clear_view_surface(surf_name,OFF,0) )exit(11);
		/* erase screen */
                break;
        case 's': lowerleft.x = getcoord();    /* set up plotting window */
                lowerleft.y = getcoord();
                upperright.x = getcoord();
                upperright.y = getcoord();
		if( vdc_extent(&lowerleft,&upperright) )exit(10);;
		/**set_charsize(xmax/80,ymax/34);**/	/* string characters */
			/* assuming full screen here */
		/**set_linewidth(linewidth);**/
                break;
        case 'm':                       /* read in current point */
                CURRENT.x = getcoord();
                CURRENT.y = getcoord();
                break;
        case 'p':                       /* plot a point */
                CURRENT.x = getcoord();
                CURRENT.y = getcoord();
		polymarker(&plist);
                break;
        case 'l':                       /* plot a line  */
		LAST = CURRENT;
                CURRENT.x = getcoord();
                CURRENT.y = getcoord();
                        /* continue on into case 'n' */
        case 'n':                       /* line from current to next*/
		LAST = CURRENT;
                CURRENT.x = getcoord();
                CURRENT.y = getcoord();
		polyline(&clist);
                break;
        case 't':       /* put a label in the graph */
		text(&CURRENT,gets(label));
		/**inquire_text_extent_2(label,&x,&y);
		xcurrent += x;**/	/* graph() assumes cursor will move */
		/**move_abs_2(xcurrent,ycurrent);**/
                break;
        case 'a':       /* draw an arc */
                fprintf(stderr,"don't know how to draw arcs\n");
                for(i=0;i<6;i++)(void)getcoord();       /* flush it */
                break;
        case 'c':       /* draw a circle */
                fprintf(stderr,"don't know how to draw circles\n");
                for(i=0;i<3;i++)(void)getcoord();       /* flush it */
                break;
        case 'f':       /* change linestyle */
		gets(label);
		if(strcmp(label,"solid")==0)line_type(SOLID);
		else if(strcmp(label,"dotted")==0)line_type(DOTTED);
		else if(strcmp(label,"shortdashed")==0)line_type(DASHED);
		else if(strcmp(label,"longdashed")==0)line_type(LONG_DASHED);
		else if(strcmp(label,"dotdashed")==0)line_type(DASHED_DOTTED);
		break;
        default: fprintf(stderr,"unknown code = %c\n",code);
    }

    /***/while(1)sleep(60);/***/
    if( close_vws(surf_name) )exit(98);
    if( close_cgi() )exit(99);

}
 
int getcoord(){
int c,d;
   c = getchar();
    d = getchar();
    return( ((d<<8)|c) );
}
